<!doctype html>
<html>
<head>
  <link rel="stylesheet" href="file:///android_asset/style.css" />
</head>
  <body>
  <h2>Principes de programmation</h2>
Les principes de programmation sont envisagés selon les quatres aspects suivants :
<ul>
  <li>Architecture <i>Android</i></li>
  <li>Composantes <i>Android</i></li>
  <li>Cycle de vie d'une Activité</li>
  <li>Fichier Manifeste</li>
</ul>
<p>L'environement mobile est un système contraint par rapport à :
<ul>
  <li>la mémoire disponible</li>
  <li>le stockage disponible</li>
  <li>la consommation de la batteries</li>
  <li>le débit réseau</li>
  <li>la diversité des appareils</li>
</ul></p>
<p>Ces contraintes sont à prendre en compte dans les pratiques de développement.
En effet, il s'agit de faire attention à :
 <ul>
  <li>la création de nouveaux objets</li>
  <li>l'utilisation des ressources (images, son, ...)</li>
  <li>l'utilisation de la batterie (animation)</li>
  <li>la vitesse du débit réseau (récupération de données sur un serveur distant)</li>
  <li>la différence d’affichage (interface utilisateur plastique)</li>
  <li>la fragmentation des versions Android (composant absent sur les versions inférieur à l'API 21)</li>
</ul>
</p>
<p>Les principes de programmation Android repose sur l'idée de contrôler les
ressources et la consommation des applications <i>Android</i>.</p>
<h3>Architecture Android</h3>
<img src="file:///android_asset/img/architecture.png" alt="Architecture Android en cinq couches"/>
<p>L'architecture <i>Android</i> est organisée en six parties distinctes :
<ol>
  <li><i>Linux Kernel</i> : noyau <i>Linux</i> servant d'interface pour le
  matériel dure (mémoire, processeur, Wifi, etc.)</li>
 <li><i>Hardware Abstraction Layer (HAL)</i> : bibliothèques exposant le matériel
dure aux composantes du systèmes.</li>
  <li><i>Android RunTime (ART)</i> : outils permettant de compiler et d'exécuter
  un projet Android.</li>
<li><i>Native C/C++ Libraries (NDK)</i> : outils permettant de générer du code natif
depuis fichiers sources <i>C/C++</i>.</li>
<li><i>Java API Framework</i> : ensemble d'outils Android, API et fonctionnalités,
permettant aux développeurs de créer des applications.</li>
<li><i>System Apps</i> : ensemble des applications de base disponibles
(Calendrier, Email, etc.).</li>
</ol></p>
<p>L'<i>ART</i> a été écrit pour exécuter plusieurs machines virtuelles sur des
appareils à faible mémoire. Dans ce sens, l'ART vise à améliorer le temps de compilation
d'un projet <i>Android</i> et la construction de l'exécutable (le fichier <i>APK</i>).</p>
<p>Plus précisement, le fichier <i>APK</i> est généré via <i>aapt</i>. Il peut
être signé afin d'être publié sur <i>Google Play</i>. Il contient :
<ul>
  <li>Code</li>
  <li>Ressources (images)</li>
  <li>Assets (ressources de type document et autres)</li>
  <li>Certificats (validité de l'application)</li>
  <li>Manifeste (autorisation demandée par l'application)</li>
</ul></p>
<h3>Composantes Android</h3>
<p>Les principales composantes <i>Android</i> sont :
<ul>
  <li><i>Activity</i></li>
  <li><i>Fragment</i></li>
  <li><i>Service</i></li>
  <li><i>BroadcastReceiver</i></li>
  <li><i>Content Provider</i></li>
  <li><i>Intent</i></li>
  <li><i>Application</i></li>
</ul></p>
<p>L'<i>Activity</i>, soit activité, est la composante incontournable d'un projet
<i>Android</i>. Elle est souvent le point d'entrée d'une application, elle
représente un écran dont la vue est décrite dans un fichier <i>XML</i>.<br>
Une application est généralement composée de plusieurs activités, devant être
déclarées dans le fichier <i>Manifeste</i>. Cela afin d'avoir l'autorisation de
s'afficher à l'écran.</p>
<p>Le <i>Fragment</i> est en quelque sorte une sous activité. Ce composant est
apparue dans la version <i>HoneyComb</i> (API 13), il vise à optimiser les
développements sur téléphone et tablette. Dans ce sens, il représente une portion
d'écran. Ce dernier peut alors être tantôt visible sur un écran de petite taille,
tantôt être combiné avec un autre <i>Fragment</i>, tous deux contenus dans une
activité, pour être visible sur un écran de tablette.<br>
Tout comme l'activité, un <i>Fragment</i> est associé à une vue <i>XML</i>, de
surcroit il possède le même comportement. Plus précisement, le comportement du
<i>Fragment</i> est calqué sur celui de l'activité qui le contient. À noter :
tout <i>Fragment</i> est contenue dans une activité.</p>
<p>Le <i>Service</i> est un processus sans interface. Son rôle est d'exécuter
un traitement en tâche de fond, notamment des traitements lourds. En particulier,
les services <i>Android</i> sont utilisés afin de :
<ul>
  <li>réaliser des appels distants à un web service</li>
  <li>télécharger des fichiers ou images</li>
  <li>accomplir des calculs intensifs</li>
  <li>lire des fichiers audio</li>
 </ul></p>
<p>Le <i>BroadcastReceiver</i>, soit récepteur d'évènements, réagit à un évènement
du système tel que la réception d'un texto, le démarrage du téléphone,
le verrouillage de l'écran, etc.<br>
Ce composant a été conçu afin de traiter des tâches légères comme lancer une
application ou bien mettre à jour des données.</p>
<p>Le <i>ContentProvider</i>, soit fournisseur de contenu, partage les données
stockées par l'application. Les données peuvent être enregistrées dans la base
de donnée SQLite ou bien dans des fichiers.<br>
Par exemple, les applications suivantes proposent du contenu à n'importe quelle
application :
<ul>
  <li>Contact</li>
  <li>Agenda</li>
  <li>Média</li>
</ul>
</p>
<p>La classe Application est instanciée tout au long de l'exécution de l'application.
Elle maintient l'état global du <i>programme Android</i>. Toute application
<i>Android</i> possède une classe <i>Application</i>. Cette classe est spécifiée
dans la balise <code>application</Code> du fichier <i>Manifeste</i>, plus précisément,
via la valeur de l'attribut <code>android:name</Code>.<br>
Il est intéressant de surcharger cette classe du <i>SDK Android</i> pour les atoûts
suivants :
<ul>
  <li>Sauvegarde de variables globales</li>
  <li>Gestion des ressources</li>
  <li>Déclaration de constantes globales</li>
</ul></p>
<p>Concrêtement, il s'agit de :
<ol>
  <li>créer une classe, nommons là par convention <code>App</code>,
  elle hérite de la classe <i>Application</i>.</li>
   <li>modifier le fichier <i>Manifeste</i> comme suit :
<code>android:name=".App"</Code>.</li>
</ol></p>
<h3>Cycle de vie d'une Activité</h3>
<p>Le système <i>Android</i> gère les ressources disponibles sur un appareil.
Ainsi, il se reserve le droit de fermer une application, cela de façon à libérer
des ressources.</p>
<p>Cependant, il obéit à deux règles avant de choisir l'application à fermer :
<ul>
  <li>prioriser par rapport à l'état du processus (en cours d'exécution)</li>
  <li>fermer le plus ancien (date)</li>
</ul></p>
<p>La pile d'écran <i>Android</i> réagit comme un navigateur web contrôlé via
le boutton de retour arrière. Dans un appareil <i>Android</i>, la pile d'écran est
principalement régit via la touche retour de ce dernier.</p>
<p>Par exemple, si l'utilisateur ouvre l'application «A», puis va sur l'écran «B» en
accédant à un élément du menu, alors les écrans A et B sont stockés dans la pile
(∅|B|A|). Ensuite, si l'utilisateur appuit sur la touche retour alors l'écran «B»
est enlevé de la pile (∅|A|).</p>
<p>L'activité possède cinq états :
<ul>
  <li>en création</li>
  <li>en cours d’exécution</li>
  <li>en pause</li>
  <li>stoppée</li>
  <li>tuée</li>
</ul>
</p>
<p>En théorie la règle est : le système ne ferme pas une application dont un
des processus (activité) est en cours d’exécution. Dans la pratique, il y a
une exception à la règle (abordé dans la  partie « Interface Utilisateur Native »).</p>
<p>Le schéma suivant, en anglais, illustre le cycle de vie d'une <i>Activity</i>.<br>
<img src="file:///android_asset/img/activity_lifecycle.png" alt="Activity lifecycle"/>
Les cinq états se retrouvent dans les méthodes associées aux mots anglais :
<ul>
  <li><i>Created, Started</i> : en création</li>
  <li><i>Resumed</i> : en cours d’exécution</li>
  <li><i>Paused</i> : en pause</li>
  <li><i>Stopped</i> : stoppée</li>
  <li><i>Destroyed</i> : tuée</li>
</ul>
</p>
<p>En particulier, les méthodes suivantes sont appelé par le système tout au long
de la durée de vie de l'application :
<ul>
  <li><i>onCreate()</i> : l’<i>Activity</i> est créée, <i>onStart()</i> est
  ensuite appelée</li>
  <li><i>onStart()</i> : l’<i>Activity</i> est visible à l’utilisateur, <i>onResume()</i>
  ou bien <i>onStop()</i> sont les méthodes pouvant être appelées après</li>
  <li><i>onResume()</i> : l’<i>Activity</i> est prête à interagir avec l’utilisateur,
  <i>onPause()</i> est la méthode appelées plus tard</li>
  <li><i>onPause()</i> : le système lance une autre <i>Activity</i>
   (/!\ implémentation courte pour la gestion des données). Les méthodes pouvant
  ensuite être appelées sont :
<i>onResume()</i> et <i>onStop()</i></li>
  <li><i>onStop()</i> : l’<i>Activity</i> n’est plus visible, Les méthodes
  pouvant ensuite être appelées sont <i>onRestart()</i> et <i>onDestroy()</i>.</li>
  <li><i>onRestart()</i> : l’<i>Activity</i> a déjà été créée (<i>onStart()</i>
  est ensuite appelée)</li>
  <li><i>onDestroy()</i> : appel final (est appelé par <i>finish()</i> ou bien
  <i>isFinishing()</i>).</li>
</ul>
</p>
<h3>Manifeste</h3>
<p>Le fichier <i>AndroidManifest.xml</i> est un fichier dans lequel est recensé
toutes les autorisations nécéssaires pour l'application.<br>
En particulier, il déclare les principales composantes d'un projet <i>Android</i> :
<ul>
  <li><i>Activities</i> où il est possible de les configurer comme étant dans
  le lanceur d’application de l'appareil, aussi le mode d'affichage peut être
  spécifié (Portrait ou Paysage)</li>
<li><i>Services</i></li>
<li><i>Permissions</i> soit les autorisations nécessaires (ex: internet, vibreur, ...).</li>
<li><i>Web Service</i></li>
</ul></p>
<p>De cette façon, au moment du téléchargement de l'application, le <i>Google Play</i>
demande explicitement les autorisations demandées par cette dernière
(ex: données de localisation, accès Photos/multimédia/fichiers).</p>
<p></p>
<p>Concrêtement, voici un example de fichier <i>Manifeste</i> :<br>
<code>
&lt;manifest xmlns:android="http://schemas.android.com/apk/res/android"  package="com.chillcoding.hello"&gt;
<br>&lt;uses-permission android:name="android.permission.INTERNET"/&gt;
&lt;application <br>android:allowBackup="true" <br>android:icon="@mipmap/ic_launcher" <br>android:label="@string/app_name" <br>android:theme="@style/AppTheme"&gt;
<br>&lt;activity <br>android:name="com.chillcoding.hello"/&gt;
&lt;/manifest&gt;
</code>
</p>
<h4>Partie suivante</h4>
<a href="file:///android_asset/1D-premierprojet.html">Créer son premier projet.</a>
<p></p>
  </body>
</html>
